import numpy as np
import matplotlib.pyplot as plt

# CT

IBC = np.loadtxt("ibc_tc_active_acc.csv", delimiter=",")
GM = np.loadtxt("gm_tc_active_acc.csv", delimiter=",")
SI = np.loadtxt("si_tc_active_acc.csv", delimiter=",")
NNR = np.loadtxt("onebit_tc_active_acc.csv", delimiter=",")
AW = np.loadtxt("adaptive_tc_active_acc.csv", delimiter=",")


plt.figure(1)
plt.plot(IBC, c="sienna", label="IBC")
plt.plot(SI, c="green", label="SIB")
plt.plot(GM, c="orange", label="GM")
plt.plot(NNR, c="aqua", label="NNRLLFM")
plt.plot(AW, c="red", label="Adaptive")
plt.ylabel("Accuracy")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Target-compound AL Accuracy Curves")

IBC2 = np.loadtxt("ibc_tc_random_acc.csv", delimiter=",")
GM2 = np.loadtxt("gm_tc_random_acc.csv", delimiter=",")
SI2 = np.loadtxt("si_tc_random_acc.csv", delimiter=",")
NNR2 = np.loadtxt("onebit_tc_random_acc.csv", delimiter=",")

plt.figure(2)
plt.plot(IBC-IBC2, c="sienna", label="IBC")
plt.plot(SI-SI2, c="green", label="SIB")
plt.plot(GM-GM2, c="orange", label="GM")
plt.plot(NNR-NNR2, c="aqua", label="NNRLLFM")
plt.ylabel("Accuracy")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Target-compound AL-Rand Accuracy Curves")


# =================================================================

IBC = np.loadtxt("ibc_tc_active_wf1.csv", delimiter=",")
GM = np.loadtxt("gm_tc_active_wf1.csv", delimiter=",")
SI = np.loadtxt("si_tc_active_wf1.csv", delimiter=",")
NNR = np.loadtxt("onebit_tc_active_wf1.csv", delimiter=",")
AW = np.loadtxt("adaptive_tc_active_wf1.csv", delimiter=",")


plt.figure(3)
plt.plot(IBC, c="sienna", label="IBC")
plt.plot(SI, c="green", label="SIB")
plt.plot(GM, c="orange", label="GM")
plt.plot(NNR, c="aqua", label="NNRLLFM")
plt.plot(AW, c="red", label="Adaptive")
plt.ylabel("Class Weighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Target-compound AL Class Weighted F1 Score Curves")

IBC2 = np.loadtxt("ibc_tc_random_wf1.csv", delimiter=",")
GM2 = np.loadtxt("gm_tc_random_wf1.csv", delimiter=",")
SI2 = np.loadtxt("si_tc_random_wf1.csv", delimiter=",")
NNR2 = np.loadtxt("onebit_tc_random_wf1.csv", delimiter=",")


plt.figure(4)
plt.plot(IBC-IBC2, c="sienna", label="IBC")
plt.plot(SI-SI2, c="green", label="SIB")
plt.plot(GM-GM2, c="orange", label="GM")
plt.plot(NNR-NNR2, c="aqua", label="NNRLLFM")
plt.ylabel("Class Weighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Target-compound AL-Rand Class Weighted F1 Score Curves")


# =================================================================

IBC = np.loadtxt("ibc_tc_active_unwf1.csv", delimiter=",")
GM = np.loadtxt("gm_tc_active_unwf1.csv", delimiter=",")
SI = np.loadtxt("si_tc_active_unwf1.csv", delimiter=",")
NNR = np.loadtxt("onebit_tc_active_unwf1.csv", delimiter=",")
AW = np.loadtxt("adaptive_tc_active_unwf1.csv", delimiter=",")


plt.figure(5)
plt.plot(IBC, c="sienna", label="IBC")
plt.plot(SI, c="green", label="SIB")
plt.plot(GM, c="orange", label="GM")
plt.plot(NNR, c="aqua", label="NNRLLFM")
plt.plot(AW, c="red", label="Adaptive")
plt.ylabel("Unweighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Target-compound AL Unweighted F1 Score Curves")

IBC2 = np.loadtxt("ibc_tc_random_unwf1.csv", delimiter=",")
GM2 = np.loadtxt("gm_tc_random_unwf1.csv", delimiter=",")
SI2 = np.loadtxt("si_tc_random_unwf1.csv", delimiter=",")
NNR2 = np.loadtxt("onebit_tc_random_unwf1.csv", delimiter=",")

plt.figure(6)
plt.plot(IBC-IBC2, c="sienna", label="IBC")
plt.plot(SI-SI2, c="green", label="SIB")
plt.plot(GM-GM2, c="orange", label="GM")
plt.plot(NNR-NNR2, c="aqua", label="NNRLLFM")
plt.ylabel("Unweighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Target-compound AL-Rand Unweighted F1 Score Curves")



#------------------------------------------------------------------------
# image


IBC = np.loadtxt("ibc_image_active_acc.csv", delimiter=",")
GM = np.loadtxt("gm_image_active_acc.csv", delimiter=",")
SI = np.loadtxt("si_image_active_acc.csv", delimiter=",")
NNR = np.loadtxt("onebit_image_active_acc.csv", delimiter=",")
AW = np.loadtxt("adaptive_image_active_acc.csv", delimiter=",")



plt.figure(7)
plt.plot(IBC, c="sienna", label="IBC")
plt.plot(SI, c="green", label="SIB")
plt.plot(GM, c="orange", label="GM")
plt.plot(NNR, c="aqua", label="NNRLLFM")
plt.plot(AW, c="red", label="Adaptive")
plt.ylabel("Accuracy")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Enzyme Activity AL Accuracy Curves")

IBC = np.loadtxt("ibc_image_random_acc.csv", delimiter=",")
GM2 = np.loadtxt("gm_image_random_acc.csv", delimiter=",")
SI = np.loadtxt("si_image_random_acc.csv'", delimiter=",")
NNR = np.loadtxt("onebit_image_random_acc.csv", delimiter=",")

plt.figure(8)
plt.plot(IBC-IBC2, c="sienna", label="IBC")
plt.plot(SI-SI2, c="green", label="SIB")
plt.plot(GM-GM2, c="orange", label="GM")
plt.plot(NNR-NNR2, c="aqua", label="NNRLLFM")
plt.ylabel("Accuracy")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Enzyme Activity AL-Rand Accuracy Curves")

# =================================================================

IBC = np.loadtxt("ibc_image_active_wf1.csv", delimiter=",")
GM = np.loadtxt("gm_image_active_wf1.csv", delimiter=",")
SI = np.loadtxt("si_image_active_wf1.csv", delimiter=",")
NNR = np.loadtxt("onebit_image_active_wf1.csv", delimiter=",")
AW = np.loadtxt("adaptive_image_active_wf1.csv", delimiter=",")



plt.figure(9)
plt.plot(IBC, c="sienna", label="IBC")
plt.plot(SI, c="green", label="SIB")
plt.plot(GM, c="orange", label="GM")
plt.plot(NNR, c="aqua", label="NNRLLFM")
plt.plot(AW, c="red", label="Adaptive")
plt.ylabel("Class Weighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Enzyme Activity AL Class Weighted F1 Score Curves")

IBC = np.loadtxt("ibc_image_random_wf1csv", delimiter=",")
GM2 = np.loadtxt("gm_image_random_wf1.csv", delimiter=",")
SI = np.loadtxt("si_image_random_wf1.csv'", delimiter=",")
NNR = np.loadtxt("onebit_image_random_wf1.csv", delimiter=",")


plt.figure(10)
plt.plot(IBC-IBC2, c="sienna", label="IBC")
plt.plot(SI-SI2, c="green", label="SIB")
plt.plot(GM-GM2, c="orange", label="GM")
plt.plot(NNR-NNR2, c="aqua", label="NNRLLFM")
plt.ylabel("Class Weighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Enzyme Activity AL-Rand Class Weighted F1 Score Curves")


# =================================================================

IBC = np.loadtxt("ibc_image_active_unwf1.csv", delimiter=",")
GM = np.loadtxt("gm_image_active_unwf1.csv", delimiter=",")
SI = np.loadtxt("si_image_active_unwf1.csv", delimiter=",")
NNR = np.loadtxt("onebit_image_active_unwf1.csv", delimiter=",")
AW = np.loadtxt("adaptive_image_active_unwf1.csv", delimiter=",")


plt.figure(11)
plt.plot(IBC, c="sienna", label="IBC")
plt.plot(SI, c="green", label="SIB")
plt.plot(GM, c="orange", label="GM")
plt.plot(NNR, c="aqua", label="NNRLLFM")
plt.plot(AW, c="red", label="Adaptive")
plt.ylabel("Unweighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Enzyme Activity AL Unweighted F1 Score Curves")

IBC = np.loadtxt("ibc_image_random_unwf1csv", delimiter=",")
GM2 = np.loadtxt("gm_image_random_unwf1.csv", delimiter=",")
SI = np.loadtxt("si_image_random_unwf1.csv'", delimiter=",")
NNR = np.loadtxt("onebit_image_random_unwf1.csv", delimiter=",")


plt.figure(12)
plt.plot(IBC-IBC2, c="sienna", label="IBC")
plt.plot(SI-SI2, c="green", label="SIB")
plt.plot(GM-GM2, c="orange", label="GM")
plt.plot(NNR-NNR2, c="aqua", label="NNRLLFM")
plt.ylabel("Unweighted F1 Score")
plt.xlabel("Round")
plt.legend(loc="best")
plt.title("Enzyme Activity AL-Rand Unweighted F1 Score Curves")


plt.show()