import numpy as np
import matplotlib.pyplot as plt

IBC = np.loadtxt("ibc_syn_random_acc.csv", delimiter=",")
GM = np.loadtxt("gm_syn_random_acc.csv", delimiter=",")
SI = np.loadtxt("si_syn_random_acc.csv", delimiter=",")
NNR = np.loadtxt("onebit_syn_random_acc.csv", delimiter=",")

obs = [19, 39, 59, 79]
# id1 = [0, 3, 12, 15, 16, 19, 28, 31, 32, 35, 44, 47]


fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC[0:4, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM[0:4, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI[0:4, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR[0:4, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=20%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC[12:16, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM[12:16, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI[12:16, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR[12:16, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=80%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC[16:20, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM[16:20, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI[16:20, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR[16:20, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=20%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC[28:32, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM[28:32, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI[28:32, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR[28:32, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=80%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC[32:36, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM[32:36, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI[32:36, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR[32:36, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=20%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC[44:48, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM[44:48, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI[44:48, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR[44:48, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=80%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Accuracy-Rand")




fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC[4:8, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM[4:8, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI[4:8, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR[4:8, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=40%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC[8:12, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM[8:12, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI[8:12, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR[8:12, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=60%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC[20:24, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM[20:24, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI[20:24, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR[20:24, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=40%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC[24:28, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM[24:28, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI[24:28, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR[24:28, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=60%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC[36:40, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM[36:40, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI[36:40, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR[36:40, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=40%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC[40:44, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM[40:44, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI[40:44, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR[40:44, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=60%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Accuracy-Rand")

#-----------------------------------------------------------------------------------------

IBC2 = np.loadtxt("ibc_syn_active_acc.csv", delimiter=",")
GM2 = np.loadtxt("gm_syn_active_acc.csv", delimiter=",")
SI2 = np.loadtxt("si_syn_active_acc.csv", delimiter=",")
NNR2 = np.loadtxt("onebit_syn_active_acc.csv", delimiter=",")
AW = np.loadtxt("adaptive_syn_active_acc.csv", delimiter=",")

obs = [19, 39, 59, 79]
# id1 = [0, 3, 12, 15, 16, 19, 28, 31, 32, 35, 44, 47]


fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC2[0:4, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM2[0:4, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI2[0:4, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR2[0:4, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten(), c="red", label="AS")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten() - SI2[0:4, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten() - IBC2[0:4, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[0].hlines(0, 0, 16, color="black")

axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=20%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC2[12:16, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM2[12:16, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI2[12:16, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR2[12:16, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten(), c="red", label="AS")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten() - SI2[12:16, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten() - IBC2[12:16, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[1].hlines(0, 0, 16, color="black")

axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=80%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC2[16:20, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM2[16:20, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI2[16:20, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR2[16:20, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten(), c="red", label="AS")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten() - SI2[16:20, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten() - IBC2[16:20, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[2].hlines(0, 0, 16, color="black")

axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=20%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC2[28:32, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM2[28:32, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI2[28:32, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR2[28:32, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten(), c="red", label="AS")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten() - SI2[28:32, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten() - IBC2[28:32, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[3].hlines(0, 0, 16, color="black")

axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=80%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC2[32:36, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM2[32:36, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI2[32:36, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR2[32:36, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten(), c="red", label="AS")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten() - SI2[32:36, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten() - IBC2[32:36, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[4].hlines(0, 0, 16, color="black")

axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=20%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC2[44:48, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM2[44:48, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI2[44:48, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR2[44:48, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten(), c="red", label="AS")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten() - SI2[44:48, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten() - IBC2[44:48, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[5].hlines(0, 0, 16, color="black")

axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=80%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Accuracy-AL")




fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC2[4:8, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM2[4:8, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI2[4:8, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR2[4:8, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten(), c="red", label="AS")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten() - SI2[4:8, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten() - IBC2[4:8, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[0].hlines(0, 0, 16, color="black")

axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=40%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC2[8:12, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM2[8:12, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI2[8:12, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR2[8:12, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten(), c="red", label="AS")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten() - SI2[8:12, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten() - IBC2[8:12, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[1].hlines(0, 0, 16, color="black")

axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=60%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC2[20:24, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM2[20:24, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI2[20:24, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR2[20:24, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten(), c="red", label="AS")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten() - SI2[20:24, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten() - IBC2[20:24, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[2].hlines(0, 0, 16, color="black")


axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=40%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC2[24:28, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM2[24:28, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI2[24:28, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR2[24:28, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten(), c="red", label="AS")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten() - SI2[24:28, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten() - IBC2[24:28, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[3].hlines(0, 0, 16, color="black")

axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=60%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC2[36:40, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM2[36:40, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI2[36:40, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR2[36:40, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten(), c="red", label="AS")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten() - SI2[36:40, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten() - IBC2[36:40, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[4].hlines(0, 0, 16, color="black")

axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=40%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC2[40:44, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM2[40:44, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI2[40:44, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR2[40:44, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten(), c="red", label="AS")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten() - SI2[40:44, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten() - IBC2[40:44, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[5].hlines(0, 0, 16, color="black")

axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=60%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Accuracy-AL")


# ===============================================================================================
# F1

IBC = np.loadtxt("ibc_syn_random_wf1.csv", delimiter=",")
GM = np.loadtxt("gm_syn_random_wf1.csv", delimiter=",")
SI = np.loadtxt("si_syn_random_wf1.csv", delimiter=",")
NNR = np.loadtxt("onebit_syn_random_wf1.csv", delimiter=",")

obs = [19, 39, 59, 79]
# id1 = [0, 3, 12, 15, 16, 19, 28, 31, 32, 35, 44, 47]


fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC[0:4, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM[0:4, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI[0:4, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR[0:4, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=20%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC[12:16, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM[12:16, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI[12:16, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR[12:16, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=80%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC[16:20, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM[16:20, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI[16:20, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR[16:20, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=20%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC[28:32, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM[28:32, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI[28:32, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR[28:32, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=80%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC[32:36, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM[32:36, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI[32:36, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR[32:36, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=20%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC[44:48, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM[44:48, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI[44:48, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR[44:48, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=80%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Class Weighted F1 Score-Rand")




fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC[4:8, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM[4:8, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI[4:8, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR[4:8, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=40%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC[8:12, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM[8:12, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI[8:12, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR[8:12, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=60%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC[20:24, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM[20:24, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI[20:24, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR[20:24, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=40%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC[24:28, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM[24:28, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI[24:28, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR[24:28, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=60%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC[36:40, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM[36:40, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI[36:40, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR[36:40, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=40%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC[40:44, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM[40:44, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI[40:44, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR[40:44, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=60%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Class Weighted F1 Score-Rand")

#-----------------------------------------------------------------------------------------

IBC2 = np.loadtxt("ibc_syn_active_wf1.csv", delimiter=",")
GM2 = np.loadtxt("gm_syn_active_wf1.csv", delimiter=",")
SI2 = np.loadtxt("si_syn_active_wf1.csv", delimiter=",")
NNR2 = np.loadtxt("onebit_syn_active_wf1.csv", delimiter=",")
AW = np.loadtxt("adaptive_syn_active_wf1.csv", delimiter=",")

obs = [19, 39, 59, 79]
# id1 = [0, 3, 12, 15, 16, 19, 28, 31, 32, 35, 44, 47]


fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC2[0:4, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM2[0:4, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI2[0:4, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR2[0:4, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten(), c="red", label="AS")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten() - SI2[0:4, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten() - IBC2[0:4, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[0].hlines(0, 0, 16, color="black")

axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=20%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC2[12:16, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM2[12:16, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI2[12:16, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR2[12:16, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten(), c="red", label="AS")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten() - SI2[12:16, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten() - IBC2[12:16, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[1].hlines(0, 0, 16, color="black")

axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=80%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC2[16:20, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM2[16:20, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI2[16:20, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR2[16:20, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten(), c="red", label="AS")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten() - SI2[16:20, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten() - IBC2[16:20, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[2].hlines(0, 0, 16, color="black")

axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=20%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC2[28:32, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM2[28:32, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI2[28:32, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR2[28:32, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten(), c="red", label="AS")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten() - SI2[28:32, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten() - IBC2[28:32, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[3].hlines(0, 0, 16, color="black")

axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=80%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC2[32:36, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM2[32:36, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI2[32:36, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR2[32:36, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten(), c="red", label="AS")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten() - SI2[32:36, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten() - IBC2[32:36, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[4].hlines(0, 0, 16, color="black")

axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=20%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC2[44:48, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM2[44:48, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI2[44:48, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR2[44:48, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten(), c="red", label="AS")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten() - SI2[44:48, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten() - IBC2[44:48, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[5].hlines(0, 0, 16, color="black")

axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=80%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Class Weighted F1 Score-AL")




fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC2[4:8, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM2[4:8, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI2[4:8, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR2[4:8, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten(), c="red", label="AS")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten() - SI2[4:8, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten() - IBC2[4:8, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[0].hlines(0, 0, 16, color="black")

axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=40%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC2[8:12, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM2[8:12, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI2[8:12, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR2[8:12, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten(), c="red", label="AS")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten() - SI2[8:12, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten() - IBC2[8:12, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[1].hlines(0, 0, 16, color="black")

axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=60%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC2[20:24, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM2[20:24, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI2[20:24, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR2[20:24, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten(), c="red", label="AS")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten() - SI2[20:24, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten() - IBC2[20:24, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[2].hlines(0, 0, 16, color="black")


axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=40%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC2[24:28, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM2[24:28, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI2[24:28, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR2[24:28, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten(), c="red", label="AS")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten() - SI2[24:28, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten() - IBC2[24:28, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[3].hlines(0, 0, 16, color="black")

axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=60%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC2[36:40, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM2[36:40, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI2[36:40, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR2[36:40, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten(), c="red", label="AS")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten() - SI2[36:40, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten() - IBC2[36:40, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[4].hlines(0, 0, 16, color="black")

axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=40%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC2[40:44, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM2[40:44, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI2[40:44, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR2[40:44, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten(), c="red", label="AS")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten() - SI2[40:44, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten() - IBC2[40:44, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[5].hlines(0, 0, 16, color="black")

axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=60%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Class Weighted F1 Score-AL")

# ===============================================================================================
# F1

IBC = np.loadtxt("ibc_syn_random_unwf1.csv", delimiter=",")
GM = np.loadtxt("gm_syn_random_unwf1.csv", delimiter=",")
SI = np.loadtxt("si_syn_random_unwf1.csv", delimiter=",")
NNR = np.loadtxt("onebit_syn_random_unwf1.csv", delimiter=",")

obs = [19, 39, 59, 79]
# id1 = [0, 3, 12, 15, 16, 19, 28, 31, 32, 35, 44, 47]


fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC[0:4, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM[0:4, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI[0:4, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR[0:4, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=20%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC[12:16, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM[12:16, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI[12:16, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR[12:16, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=80%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC[16:20, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM[16:20, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI[16:20, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR[16:20, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=20%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC[28:32, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM[28:32, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI[28:32, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR[28:32, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=80%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC[32:36, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM[32:36, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI[32:36, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR[32:36, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=20%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC[44:48, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM[44:48, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI[44:48, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR[44:48, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=80%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Unweighted F1 Score-Rand")




fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC[4:8, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM[4:8, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI[4:8, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR[4:8, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=40%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC[8:12, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM[8:12, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI[8:12, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR[8:12, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=60%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC[20:24, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM[20:24, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI[20:24, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR[20:24, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=40%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC[24:28, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM[24:28, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI[24:28, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR[24:28, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=60%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC[36:40, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM[36:40, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI[36:40, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR[36:40, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=40%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC[40:44, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM[40:44, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI[40:44, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR[40:44, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=60%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Unweighted F1 Score-Rand")

#-----------------------------------------------------------------------------------------

IBC2 = np.loadtxt("ibc_syn_active_unwf1.csv", delimiter=",")
GM2 = np.loadtxt("gm_syn_active_unwf1.csv", delimiter=",")
SI2 = np.loadtxt("si_syn_active_unwf1.csv", delimiter=",")
NNR2 = np.loadtxt("onebit_syn_active_unwf1.csv", delimiter=",")
AW = np.loadtxt("adaptive_syn_active_unwf1.csv", delimiter=",")

obs = [19, 39, 59, 79]
# id1 = [0, 3, 12, 15, 16, 19, 28, 31, 32, 35, 44, 47]


fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC2[0:4, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM2[0:4, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI2[0:4, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR2[0:4, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten(), c="red", label="AS")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten() - SI2[0:4, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[0].scatter(np.arange(16), AW[0:4, obs].flatten() - IBC2[0:4, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[0].hlines(0, 0, 16, color="black")

axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=20%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC2[12:16, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM2[12:16, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI2[12:16, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR2[12:16, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten(), c="red", label="AS")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten() - SI2[12:16, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[1].scatter(np.arange(16), AW[12:16, obs].flatten() - IBC2[12:16, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[1].hlines(0, 0, 16, color="black")

axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=80%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC2[16:20, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM2[16:20, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI2[16:20, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR2[16:20, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten(), c="red", label="AS")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten() - SI2[16:20, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[2].scatter(np.arange(16), AW[16:20, obs].flatten() - IBC2[16:20, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[2].hlines(0, 0, 16, color="black")

axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=20%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC2[28:32, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM2[28:32, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI2[28:32, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR2[28:32, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten(), c="red", label="AS")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten() - SI2[28:32, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[3].scatter(np.arange(16), AW[28:32, obs].flatten() - IBC2[28:32, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[3].hlines(0, 0, 16, color="black")

axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=80%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC2[32:36, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM2[32:36, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI2[32:36, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR2[32:36, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten(), c="red", label="AS")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten() - SI2[32:36, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[4].scatter(np.arange(16), AW[32:36, obs].flatten() - IBC2[32:36, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[4].hlines(0, 0, 16, color="black")

axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=20%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC2[44:48, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM2[44:48, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI2[44:48, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR2[44:48, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten(), c="red", label="AS")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten() - SI2[44:48, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[5].scatter(np.arange(16), AW[44:48, obs].flatten() - IBC2[44:48, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[5].hlines(0, 0, 16, color="black")

axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=80%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Unweighted F1 Score-AL")




fig, axes = plt.subplots(3, 2)
axes = axes.ravel()
axes[0].scatter(np.arange(16), IBC2[4:8, obs].flatten(), c="sienna", label="IBC")
axes[0].scatter(np.arange(16), GM2[4:8, obs].flatten(), c="orange", label="GM")
axes[0].scatter(np.arange(16), SI2[4:8, obs].flatten(), c="green", label="SIB")
axes[0].scatter(np.arange(16), NNR2[4:8, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten(), c="red", label="AS")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten() - SI2[4:8, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[0].scatter(np.arange(16), AW[4:8, obs].flatten() - IBC2[4:8, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[0].hlines(0, 0, 16, color="black")

axes[0].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[0].set_title("uniqueness=40%, noise=0%")
axes[0].axes.get_xaxis().set_visible(False)

axes[1].scatter(np.arange(16), IBC2[8:12, obs].flatten(), c="sienna", label="IBC")
axes[1].scatter(np.arange(16), GM2[8:12, obs].flatten(), c="orange", label="GM")
axes[1].scatter(np.arange(16), SI2[8:12, obs].flatten(), c="green", label="SIB")
axes[1].scatter(np.arange(16), NNR2[8:12, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten(), c="red", label="AS")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten() - SI2[8:12, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[1].scatter(np.arange(16), AW[8:12, obs].flatten() - IBC2[8:12, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[1].hlines(0, 0, 16, color="black")

axes[1].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[1].set_title("uniqueness=60%, noise=0%")
axes[1].axes.get_xaxis().set_visible(False)

axes[2].scatter(np.arange(16), IBC2[20:24, obs].flatten(), c="sienna", label="IBC")
axes[2].scatter(np.arange(16), GM2[20:24, obs].flatten(), c="orange", label="GM")
axes[2].scatter(np.arange(16), SI2[20:24, obs].flatten(), c="green", label="SIB")
axes[2].scatter(np.arange(16), NNR2[20:24, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten(), c="red", label="AS")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten() - SI2[20:24, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[2].scatter(np.arange(16), AW[20:24, obs].flatten() - IBC2[20:24, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[2].hlines(0, 0, 16, color="black")


axes[2].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[2].set_title("uniqueness=40%, noise=10%")
axes[2].axes.get_xaxis().set_visible(False)

axes[3].scatter(np.arange(16), IBC2[24:28, obs].flatten(), c="sienna", label="IBC")
axes[3].scatter(np.arange(16), GM2[24:28, obs].flatten(), c="orange", label="GM")
axes[3].scatter(np.arange(16), SI2[24:28, obs].flatten(), c="green", label="SIB")
axes[3].scatter(np.arange(16), NNR2[24:28, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten(), c="red", label="AS")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten() - SI2[24:28, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[3].scatter(np.arange(16), AW[24:28, obs].flatten() - IBC2[24:28, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[3].hlines(0, 0, 16, color="black")

axes[3].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[3].set_title("uniqueness=60%, noise=10%")
axes[3].axes.get_xaxis().set_visible(False)

axes[4].scatter(np.arange(16), IBC2[36:40, obs].flatten(), c="sienna", label="IBC")
axes[4].scatter(np.arange(16), GM2[36:40, obs].flatten(), c="orange", label="GM")
axes[4].scatter(np.arange(16), SI2[36:40, obs].flatten(), c="green", label="SIB")
axes[4].scatter(np.arange(16), NNR2[36:40, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten(), c="red", label="AS")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten() - SI2[36:40, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[4].scatter(np.arange(16), AW[36:40, obs].flatten() - IBC2[36:40, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[4].hlines(0, 0, 16, color="black")

axes[4].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[4].set_title("uniqueness=40%, noise=20%")
axes[4].axes.get_xaxis().set_visible(False)

axes[5].scatter(np.arange(16), IBC2[40:44, obs].flatten(), c="sienna", label="IBC")
axes[5].scatter(np.arange(16), GM2[40:44, obs].flatten(), c="orange", label="GM")
axes[5].scatter(np.arange(16), SI2[40:44, obs].flatten(), c="green", label="SIB")
axes[5].scatter(np.arange(16), NNR2[40:44, obs].flatten(), c="aqua", label="NNRLLFMB")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten(), c="red", label="AS")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten() - SI2[40:44, obs].flatten(), c="green", marker="D", label="AS-SIB")
axes[5].scatter(np.arange(16), AW[40:44, obs].flatten() - IBC2[40:44, obs].flatten(), c="sienna", marker="s", label="AS-IBC")
axes[5].hlines(0, 0, 16, color="black")

axes[5].axvline(x=3.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=7.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].axvline(x=11.5, ymin=0, ymax=1, color="black", ls = "--")
axes[5].set_title("uniqueness=60%, noise=20%")
axes[5].axes.get_xaxis().set_visible(False)

handles, labels = axes[0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center')
plt.suptitle("Unweighted F1 Score-AL")

plt.show()