%
function mtx = solver(idx_, y_, r, d1, d2)
    cP = cell(idx_);
    idx = cellfun(@double,cP)';
    y_temp = cell(y_);
    y = cellfun(@double,y_temp)';
%     d1= 210;
%     d2 = 195;
    sigma = 0.3;
    f      = @(x) gausscdf(x,0,sigma);
    fprime = @(x) gausspdf(x,0,sigma);
    % Logistic model
    %f       = @(x) (1 ./ (1 + exp(-x)));
    %fprime  = @(x) (exp(x) ./ (1 + exp(x)).^2); 
    options = struct();
    options.iterations = 100; 
    options.stepMax    = 10000;
    options.stepMin    = 1e-4;
    options.optTol     = 1e-3;
    options.stepMax    = 1e9;
    funObj  = @(x) logObjectiveGeneral(x,y,idx,f,fprime);
    alpha   = 1;
    radius  = alpha * sqrt(d1*d2*r);
    funProj = @(x,projTol,projData) projNucnorm(x,d1,d2,radius,projTol,projData);
    [Mhat,~] = spgSolver(funObj, funProj, zeros(d1*d2,1), options);
    Mhat = reshape(Mhat,d1,d2);
    mtx = f(Mhat);
end